VERSION 5.00
Begin VB.UserControl RotateLabelVer2 
   BackColor       =   &H00FFFFFF&
   ClientHeight    =   1032
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1356
   DrawStyle       =   2  'Dot
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   16.2
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H000000FF&
   PropertyPages   =   "RotateLableVer2.ctx":0000
   ScaleHeight     =   86
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   113
   ToolboxBitmap   =   "RotateLableVer2.ctx":002D
End
Attribute VB_Name = "RotateLabelVer2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_HelpID = 1
Attribute VB_Description = "Access Rotate Text Control 2.0"
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
    Option Explicit
    
    'First of all, if you must throw stones, use small ones! :-)
    'This is my First ActiveX control and I knew nothing of ActiveX
    'when I started..and it shows.
    '
    '
    'Half of this source code, including the Trig routines are
    'from Rod Stephens' book "Custom Control Library". This book
    'has been an invaluable tool, highly recommended!
    'I have left the original copyright notice in the
    'About Box which can be accessed through the Property Sheet.
    'On my Web page you'll find several function to produce
    'Rotated Text for Access. Unfortunately they were all produced
    'before I found Rod's book. My Trig functions for calculating
    'bounding boxes and rotation are weak at best. I was very
    'happy to finally find the functions I required all in one
    'place, Rod's book!
    '
    'I have Rod's permission to post his rotation and bounding
    'box Trig routines.
    '
    'Name:                  RotateLabelVer2
    'Modified/Created by:   Stephen Lebans
    'Date:                  July 27, 1999
    'Time:                  12:34:05am
    'Purpose:               Produce Rotated Text in
    '                       Microsoft Access.
    '                       Can be bound to a Field.
    '
    'Feedback:              macarthu@nbnet.nb.ca
    'My Web Page:           http://www.geocities.com/~slebans
    '
    'I have disabled the AutoSize logic in the control.
    'It does not function within the Access Print Preview
    'Or Print functions.
    'Also the Border Drawing routines are disabled.
    
    'A lot of ActiveX controls do not function properly
    'within the VBA Access environment. A lot of it has to do
    'with differences in the Extender and Ambient control properties.
    'It took a lot of trial and error to get this control to
    'work in both Form and Report views. If you find that you
    'have to make a changes for it to work in your environment
    'please let me know so that I can incorporate it into the next
    'release.
    'Enjoy
    'Stephen Lebans
    
    '***************Code Start***************
    
    
    ' *****************
    ' Enumerated types.
    ' *****************
    
    ' Horizontal alignment.
    Enum tiltlabel_HAlignment
        Left_tiltlabel_HAlign
        Center_tiltlabel_HAlign
        Right_tiltlabel_HAlign
    End Enum
    
    ' Vertical alignment.
    Enum tiltlabel_VAlignment
        Top_tiltlabel_VAlign
        Middle_tiltlabel_VAlign
        Bottom_tiltlabel_VAlign
    End Enum
    
    ' Border styles.
    Enum tiltlabel_BorderStyle
        Solid_tiltlabel_BorderStyle = vbSolid
        Dash_tiltlabel_BorderStyle = vbDash
        Dot_tiltlabel_BorderStyle = vbDot
        DashDot_tiltlabel_BorderStyle = vbDashDot
        DashDotDot_tiltlabel_BorderStyle = vbDashDotDot
        None_tiltlabel_BorderStyle = vbInvisible
    End Enum
    
    ' ***********************
    'Default Property Values:
    Const m_def_testbound = 0
    Const m_def_Caption = "45 Degrees"
    Const m_def_BorderStyle = None_tiltlabel_BorderStyle
    'Const m_def_AutoSize = 0
    Const m_def_HAlignment = Center_tiltlabel_HAlign
    Const m_def_VAlignment = Middle_tiltlabel_VAlign
    Const m_def_BackColor = vbWhite
    Const m_def_ForeColor = vbBlack
    Const m_def_Escapement = 45
    Const m_def_FontName = "Arial"
    Const m_def_FontSize = 12
    Const m_def_FontBold = True
    Const LOGPIXELSY = 90        '  Logical pixels/inch in Y

    'Property Variables:
    Dim m_testbound As Variant
    Dim m_Caption As String
    Dim m_BorderStyle As tiltlabel_BorderStyle
    Dim m_AutoSize As Boolean
    
    Dim lngYdpi As Long
    Dim lngIc As Long
    
    Dim fHeight As Long
    'calculate screen Font height
    
    Dim m_HAlignment As tiltlabel_HAlignment
    Dim m_VAlignment As tiltlabel_VAlignment
    Dim m_Escapement As Single
    
    
    'Event Declarations:
    Event GetDataMember(DataMember As String, Data As Object) 'MappingInfo=UserControl,UserControl,-1,GetDataMember
    Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
    Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
    
        Private skip_redraw As Boolean
    'Property Variables:
    'I needed a font constant.
    'Without the constant, I was generating a
    'RunTIme error on a GUI Cut & Paste operation.
    Dim m_def_Font As StdFont
    Private WithEvents mFont As StdFont
Attribute mFont.VB_VarHelpID = -1

    
    ' *********************************************
    ' Show the About dialog.
    ' *********************************************
    Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
    Dim frm As New AboutDialog
    
        frm.Show vbModal
        Set frm = Nothing
    End Sub
    
    'Public Property Get AutoSize() As Boolean
     '   AutoSize = m_AutoSize
    'End Property
    
    'Public Property Let AutoSize(ByVal New_AutoSize As Boolean)
     '   m_AutoSize = New_AutoSize
      '  PropertyChanged "AutoSize"
       ' UserControl_Paint   ' Redraw.
    'End Property
    
    
    Public Property Get HAlignment() As tiltlabel_HAlignment
Attribute HAlignment.VB_Description = "The control's horizontal alignment."
        HAlignment = m_HAlignment
    End Property
    
    Public Property Let HAlignment(ByVal New_HAlignment As tiltlabel_HAlignment)
        m_HAlignment = New_HAlignment
        PropertyChanged "HAlignment"
        UserControl_Paint   ' Redraw.
    End Property
    
    Public Property Get VAlignment() As tiltlabel_VAlignment
Attribute VAlignment.VB_Description = "The control's vertical alignment."
        VAlignment = m_VAlignment
    End Property
    
    Public Property Let VAlignment(ByVal New_VAlignment As tiltlabel_VAlignment)
        m_VAlignment = New_VAlignment
        PropertyChanged "VAlignment"
        UserControl_Paint   ' Redraw.
    End Property
    
    Public Property Get Escapement() As Single
Attribute Escapement.VB_Description = "The angle at which the Caption is drawn."
Attribute Escapement.VB_ProcData.VB_Invoke_Property = "General"
        Escapement = m_Escapement
    End Property
    
    Public Property Let Escapement(ByVal New_Escapement As Single)
        m_Escapement = New_Escapement
        PropertyChanged "Escapement"
        UserControl_Paint   ' Redraw.
    End Property
    
    
    
    'Setup font as Arial 12 on control initialize
    Private Sub UserControl_Initialize()
    Set mFont = New StdFont
    With mFont
       .Name = m_def_FontName
      .Size = m_def_FontSize
    End With
    Set UserControl.Font = mFont
    
    'Setup constant font  :-)
    Set m_def_Font = New StdFont
    With m_def_Font
        .Name = m_def_FontName
        .Size = m_def_FontSize
    End With
    
    'fixes Cut&Paste Access problem
    End Sub
    
    
    'Initialize Properties for User Control
    Private Sub UserControl_InitProperties()
        Dim varBack As Variant
        Dim varFore As Variant
        skip_redraw = True
    
       ' m_AutoSize = m_def_AutoSize
        m_Caption = m_def_Caption
        m_HAlignment = m_def_HAlignment
        m_VAlignment = m_def_VAlignment
        m_Escapement = m_def_Escapement
        m_BorderStyle = m_def_BorderStyle
    
        
        '**********************
        'error code to handle if no ambient Fore or Back Props
        On Error Resume Next
        varBack = Ambient.BackColor
        If Not IsNull(varBack) Then
        UserControl.BackColor = Ambient.BackColor
        Else: UserControl.BackColor = m_def_BackColor
        End If
        
        On Error Resume Next
        varFore = Ambient.ForeColor
        If Not IsNull(varFore) Then
        UserControl.ForeColor = Ambient.ForeColor
        Else: UserControl.ForeColor = m_def_ForeColor
        End If
        '*************************
               
        m_Caption = m_def_Caption
        m_testbound = m_def_testbound
        Set mFont = UserControl.Font
        skip_redraw = False
         
        UserControl_Paint   ' Redraw.
      
    End Sub
    
    Private Sub UserControl_Paint()
    Const FW_NORMAL = 400       ' Normal font weight.
    Const FW_BOLD = 700         ' Bold font weight.
    Const CLIP_LH_ANGLES = 16   ' Needed for tilted fonts.
    Const PI = 3.14159625
    Const PI_180 = PI / 180#
    
    Dim newfont As Long
    Dim oldfont As Long
    Dim wgt As Long
    Dim x(1 To 4) As Single
    Dim y(1 To 4) As Single
    Dim xmin As Single
    Dim xmax As Single
    Dim ymin As Single
    Dim ymax As Single
    Dim stheta As Single
    Dim ctheta As Single
    Dim I As Integer
    Dim tmp As Single
    Dim lngret As Long
          
        ' Do nothing if we're loading.
        If skip_redraw Then Exit Sub
        
        ' Start from scratch..let's clear the screen.
        Cls
        
        ' Create the font.
        If Font.Bold Then
            wgt = FW_BOLD
        Else
            wgt = FW_NORMAL
        End If
        
        '*****DELETE IC******
        'Modified to allow for different screen resolutions
        'and printer output
        'Calculate Font size
        lngIc = CreateIC("DISPLAY", vbNullString, vbNullString, vbNullString)
        If lngIc <> 0 Then
            lngYdpi = GetDeviceCaps(lngIc, LOGPIXELSY)
            DeleteDC (lngIc)
            
            'fHeight = MulDiv(FontSize, GetDeviceCaps(hDC, LOGPIXELSY), 72)
            'I thought above was required logic. Give it a try to see why not!
                
            Else: lngYdpi = 120 'Default average value
        End If
        
        
        'I had to make a few changes to the Trig routines
        'to accomodate the new font size routines
        'Bounding Box problem no Negative value!!!!
        'We use a negative value to signify
        'to the CreateFont function that we want a Glyph
        'outline of this size not a bounding box.
                
        fHeight = MulDiv(Font.Size, lngYdpi, 72)
        
        'I use negative Fheight to get Glyph not Box
        'this would throwoff TRIG CENTER/JUST CALCS
        newfont = CreateFont(-fHeight, 0, _
            CLng(Escapement * 10), CLng(Escapement * 10), wgt, _
            Font.Italic, Font.Underline, _
            Font.Strikethrough, 0, 0, _
            CLIP_LH_ANGLES, 0, 0, Font.Name)
            
        
        ' Select the new font.
        oldfont = SelectObject(hdc, newfont)
    
        ' Calculate a bounding box for the text.
        x(1) = 0
        x(2) = TextWidth(Caption)
        x(3) = x(2)
        x(4) = 0
        y(1) = 0
        y(2) = 0
        y(3) = fHeight 'Font.Size
        y(4) = y(3)
    
        ' Rotate the bounding box.
        stheta = Sin(Escapement * PI_180)
        ctheta = Cos(Escapement * PI_180)
        For I = 2 To 4
            tmp = x(I) * ctheta + y(I) * stheta
            y(I) = -x(I) * stheta + y(I) * ctheta
            x(I) = tmp
        Next I
        
        ' Bound the rotated bounding box.
        xmin = x(1)
        xmax = xmin
        ymin = y(1)
        ymax = ymin
        For I = 2 To 4
            If xmin > x(I) Then xmin = x(I)
            If xmax < x(I) Then xmax = x(I)
            If ymin > y(I) Then ymin = y(I)
            If ymax < y(I) Then ymax = y(I)
        Next I
    
         'If AutoSize is True, resize to fit.
        'If AutoSize Then
         '  Size ScaleX(xmax - xmin + 1, vbPixels, vbTwips), _
          ' ScaleY(ymax - ymin + 1, vbPixels, vbTwips)
        'End If
        
        ' Set the current point based on alignment.
        If HAlignment = Left_tiltlabel_HAlign Then
            For I = 1 To 4
                x(I) = x(I) - xmin
            Next I
        ElseIf HAlignment = Right_tiltlabel_HAlign Then
            tmp = ScaleWidth - xmax
            For I = 1 To 4
                x(I) = tmp + x(I)
            Next I
        Else
            tmp = ScaleWidth / 2 - (xmin + xmax) / 2
            For I = 1 To 4
                x(I) = tmp + x(I)
            Next I
        End If
        If VAlignment = Top_tiltlabel_VAlign Then
            For I = 1 To 4
                y(I) = y(I) - ymin
            Next I
        ElseIf VAlignment = Bottom_tiltlabel_VAlign Then
            tmp = ScaleHeight - ymax
            For I = 1 To 4
                y(I) = tmp + y(I)
            Next I
        Else
            tmp = ScaleHeight / 2 - (ymin + ymax) / 2
            For I = 1 To 4
                y(I) = tmp + y(I)
            Next I
        End If
        
        ' Display the text.
        CurrentX = x(1)
        CurrentY = y(1)
        On Error Resume Next
        
        ' Changed from Print to TextOut for compatability
        ' Print cause an OverFlow error for a UserDrawn Control
        ' in the VB IDE.
        
        ' In the VB IDE the Font color displays properly
        ' but prints in Black only.
        ' I don't know if this is simply me picking a non system color
        ' Or whatever. I really can't see using this control in VB
        ' becasue it would make more sense to print the Rotated Text
        ' directly yourself. Anyhow, if for some reason you do need to
        ' use this control in VB, probably just bracket the TextOut
        ' call with SetTextColor calls to set and reset the DC's current
        ' selection for Forecolor.
        
        lngret = TextOut(hdc, CurrentX, CurrentY, Caption, Len(Caption))
       
        ' I commented out Border Draw function because it
        ' was causing problems in Access during Print Preview.
        ' It's really used in the AutResize funciton which is disabled
        ' again because of compatability problems running in Access.
        ' Draw the border if desired.
        ' If BorderStyle <> None_tiltlabel_BorderStyle Then
        '     DrawStyle = BorderStyle
        '     Line (x(1), y(1))-(x(2), y(2))
        '     Line -(x(3), y(3))
        '     Line -(x(4), y(4))
        '     Line -(x(1), y(1))
        '     DrawStyle = vbDot
        ' End If
    
        ' Restore the original font.
        newfont = SelectObject(hdc, oldfont)
        DeleteObject newfont
        
        ' I left this out for Access but it works fine in VB
        ' and now that the control is stable is probably
        ' works in Access as well
        ' If it's design time, also draw a dotted box.
        ' If Not Ambient.UserMode Then
        ' Line (0, 0)-(ScaleWidth - 1, ScaleHeight - 1), , B
        ' End If
   
    End Sub
    
    'Load property values from storage
    Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
     skip_redraw = True
    
        ' m_AutoSize = PropBag.ReadProperty("AutoSize", m_def_AutoSize)
        m_HAlignment = PropBag.ReadProperty("HAlignment", m_def_HAlignment)
        m_VAlignment = PropBag.ReadProperty("VAlignment", m_def_VAlignment)
        m_Escapement = PropBag.ReadProperty("Escapement", m_def_Escapement)
        m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
   
        UserControl.ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
        UserControl.BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
                
        Set mFont = PropBag.ReadProperty("Font", m_def_Font) 'UserControl.Font)
        m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
        m_testbound = PropBag.ReadProperty("testbound", m_def_testbound)
    
        'UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
        skip_redraw = False
        UserControl_Paint   ' Redraw.
    
    End Sub
    
    'Write property values to storage
    Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
        
        'Call PropBag.WriteProperty("AutoSize", m_AutoSize, m_def_AutoSize)
        
        Call PropBag.WriteProperty("HAlignment", m_HAlignment, m_def_HAlignment)
        Call PropBag.WriteProperty("VAlignment", m_VAlignment, m_def_VAlignment)
       
        Call PropBag.WriteProperty("Escapement", m_Escapement, m_def_Escapement)
        Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, m_def_ForeColor)
        
        Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
        Call PropBag.WriteProperty("BackColor", UserControl.BackColor, m_def_BackColor)

        Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
        Call PropBag.WriteProperty("testbound", m_testbound, m_def_testbound)
    
        Call PropBag.WriteProperty("Font", mFont, m_def_Font)
   
        ' Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    End Sub
    
    'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
    'MappingInfo=UserControl,UserControl,-1,ForeColor
    Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "The foreground color used to display the Caption."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = "StandardColor"
        ForeColor = UserControl.ForeColor
    End Property
    
    Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
        UserControl.ForeColor() = New_ForeColor
        PropertyChanged "ForeColor"
        UserControl_Paint   ' Redraw.
    End Property

    'Public Property Get BorderStyle() As tiltlabel_BorderStyle
    'BorderStyle = m_BorderStyle
    'End Property
    '
    'Public Property Let BorderStyle(ByVal New_BorderStyle As tiltlabel_BorderStyle)
    'm_BorderStyle = New_BorderStyle
    'PropertyChanged "BorderStyle"
    'UserControl_Paint   ' Redraw.
    'End Property
    
    Private Sub UserControl_Click()
        RaiseEvent Click
    End Sub
    
    Private Sub UserControl_DblClick()
        RaiseEvent DblClick
    End Sub
    
    'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
    'MappingInfo=UserControl,UserControl,-1,BackColor
    Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = "StandardColor"
        BackColor = UserControl.BackColor
    End Property
    
    Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
        UserControl.BackColor() = New_BackColor
        PropertyChanged "BackColor"
        'UserControl_Paint   ' Redraw.
    End Property
    
    Public Property Get Font() As StdFont
Attribute Font.VB_ProcData.VB_Invoke_Property = "StandardFont"
Attribute Font.VB_UserMemId = -512
        Set Font = mFont
    End Property

    Public Property Set Font(mnewfont As StdFont)

    With mFont
        .Bold = mnewfont.Bold
        .Italic = mnewfont.Italic
        .Name = mnewfont.Name
        .Size = mnewfont.Size
        End With
    
    PropertyChanged "Font"
    End Property
    
    'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
    'MappingInfo=UserControl,UserControl,-1,DataMembers
    Public Property Get DataMembers() As DataMembers
Attribute DataMembers.VB_Description = "Returns a collection of data members to show at design time for this data source."
        Set DataMembers = UserControl.DataMembers
    End Property
    
    'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
    'MappingInfo=UserControl,UserControl,-1,DataMemberChanged
        Public Sub DataMemberChanged(ByVal DataMember As String)
Attribute DataMemberChanged.VB_Description = "Notify data consumers that a data member of this data source has changed."
            UserControl.DataMemberChanged DataMember
        End Sub
    
    Private Sub UserControl_GetDataMember(DataMember As String, Data As Object)
    RaiseEvent GetDataMember(DataMember, Data)
    
        UserControl_Paint   ' Redraw.
    End Sub
    
    'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
    'MemberInfo=13,0,0,
    Public Property Get Caption() As String
Attribute Caption.VB_Description = "The text displayed in the label or data field if bound."
Attribute Caption.VB_ProcData.VB_Invoke_Property = "General"
Attribute Caption.VB_MemberFlags = "24"
        Caption = m_Caption
    End Property
    
    Public Property Let Caption(ByVal New_Caption As String)
        m_Caption = New_Caption
        PropertyChanged "Caption"
    
        UserControl_Paint   ' Redraw.
    End Property
    
    'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
    'MemberInfo=14,0,0,0
    Public Property Get testbound() As Variant
Attribute testbound.VB_Description = "test to see if I can bind(not my shorts!)  :-)"
Attribute testbound.VB_ProcData.VB_Invoke_Property = "General"
        testbound = m_testbound
    End Property
    
    Public Property Let testbound(ByVal New_testbound As Variant)
        m_testbound = New_testbound
        PropertyChanged "testbound"
    End Property
    
    'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
    'MappingInfo=UserControl,UserControl,-1,Refresh
    Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
        UserControl.Refresh
    End Sub


    Private Sub mFont_FontChanged(ByVal PropertyName As String)
        Set UserControl.Font = mFont
        Refresh 'UserControl_Paint no diff here
    End Sub

 
    'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
    'MappingInfo=UserControl,UserControl,-1,BorderStyle
    Public Property Get BorderStyle() As tiltlabel_BorderStyle
Attribute BorderStyle.VB_Description = "Returns/sets the style for a rotated box to be drawn around the text."
        BorderStyle = UserControl.BorderStyle
    End Property

    Public Property Let BorderStyle(ByVal New_BorderStyle As tiltlabel_BorderStyle)
        UserControl.BorderStyle() = New_BorderStyle
        PropertyChanged "BorderStyle"
    End Property

